!---------------------------------------------------------------------
!     Copyright (C) GFD Dennou Club, 2006. All rights reserved.
!---------------------------------------------------------------------
!
!= 3  (xyz ) ֳָ߳ʻ ʬ黻⥸塼
!
!* 
!  * 2007/07/15 () : 3D deepconv ذܿ, dc_types  Use.
!  * 2007/06/27 () : 1 ʬ黻⥸塼˰¸ʤ褦
!  * 2006/06/07 () : 
!

module xyz_deriv_c4_module
  != 3  (xyz ) ֳָ߳ʻ ʬ黻⥸塼
  !
  !== ǽ
  !
  ! xyz_deriv_module , 3  (xyz ) ֳָ߳ʻҤѤͭºʬ
  ! ˡ˴ŤͥǥΤ, ʬ黻Ԥ Fortran90 ؿ󶡤. 
  ! ʬ黻 4 濴ʬѤƹԤ.
  !
  ! Υ⥸塼ϲ⥸塼Ȥ xyz_base_module, data_type 
  ! ⥸塼ѤƤ. 
  !
  ! ⥸塼ѿȼ³̿̾ˡˤĤƤ xyz_module 򻲾ȤΤ.
  !
  !
  !== ѿ, ³
  !
  !=== 1 ʬ
  !
  ! xyz_dx_pyz, pyz_dx_xyz :: x  1 ʬ׻
  ! xyz_dy_xqz, xqz_dy_xyz :: y  1 ʬ׻
  ! xyz_dz_xyr, xyr_dz_xyz :: z  1 ʬ׻
  !
  !
  !== 
  !
  ! ʬϳʻҴֳ֤Ȥ
  !
  !    du/dx(i) = 9/8*[u(i)-u(i-1)]/dx(i) - 1/24*[u(i+1)-u(i-2)]/dx(i)
  ! 
  ! ѤƤ. ֳֳʻҤξ٤뤳Ȥ.
  !

  use dc_types,        only : DBKIND => DP
  use dc_message,      only: MessageNotify
  use xyz_base_module, only : imin, imax, jmin, jmax, kmin, kmax, &
    &                         x_dx, p_dx, y_dy, q_dy, z_dz, r_dz       

  implicit none
  private
  public :: xyz_dx_pyz, pyz_dx_xyz, pyr_dx_xyr, pqz_dx_xqz, &
    &       xyz_dy_xqz, xqz_dy_xyz, pqz_dy_pyz, xqr_dy_xyr, &
    &       xyz_dz_xyr, xyr_dz_xyz, pyr_dz_pyz, xqr_dz_xqz

  interface pyz_dx_xyz
    module procedure paa_dx_xaa
  end interface

  interface pyr_dx_xyr
    module procedure paa_dx_xaa
  end interface

  interface pqz_dx_xqz
    module procedure paa_dx_xaa
  end interface
 
  interface xqz_dy_xyz
    module procedure aqa_dy_aya
  end interface

  interface pqz_dy_pyz
    module procedure aqa_dy_aya
  end interface

  interface xqr_dy_xyr
    module procedure aqa_dy_aya
  end interface

  interface xyr_dz_xyz
    module procedure aar_dz_aaz
  end interface

  interface pyr_dz_pyz
    module procedure aar_dz_aaz
  end interface

  interface xqr_dz_xqz
    module procedure aar_dz_aaz
  end interface



  contains
!--------------------------------------------------------------------
    function xyz_dx_pyz(pyz_Var)
      ! Ⱦʻ 1 ʬ׻
  
      real(DBKIND),intent(in) :: pyz_Var(imin:imax,jmin:jmax,kmin:kmax) 
      real(DBKIND)            :: xyz_dx_pyz(imin:imax,jmin:jmax,kmin:kmax)
      integer                 :: ix                          

      ! 
      ! * 0 ɤˤϥޥ󥤥ץͤѤ٤
      !
      xyz_dx_pyz = 0.0d0

      ! 1 ʬη׻
      !
      do ix = imin+2, imax-1
        xyz_dx_pyz(ix,:,:) = &
          &   ((pyz_Var(ix,:,:)   - pyz_Var(ix-1,:,:))*9.0d0/(8.0d0*x_dx(ix)) &
          & - ((pyz_Var(ix+1,:,:) - pyz_Var(ix-2,:,:))/(24.0d0*x_dx(ix))))
      end do

    end function xyz_dx_pyz
!--------------------------------------------------------------------
    function paa_dx_xaa(xaa_Var)
      ! Ⱦʻ 1 ʬ׻
  
      real(DBKIND),intent(in) :: xaa_Var(imin:imax,jmin:jmax,kmin:kmax) 
      real(DBKIND)            :: paa_dx_xaa(imin:imax,jmin:jmax,kmin:kmax)
      integer                 :: ix                          

      ! 
      ! * 0 ɤˤϥޥ󥤥ץͤѤ٤
      !
      paa_dx_xaa = 0.0d0

      ! 1 ʬη׻
      !
      do ix = imin+1, imax-2
        paa_dx_xaa(ix,:,:) = &
          &   ((xaa_Var(ix+1,:,:) - xaa_Var(ix,:,:))*9.0d0/(8.0d0*p_dx(ix)) &
          & - ((xaa_Var(ix+2,:,:) - xaa_Var(ix-1,:,:))/(24.0d0*p_dx(ix))))
      end do

    end function paa_dx_xaa
!--------------------------------------------------------------------
    function xyz_dy_xqz(xqz_Var)
      ! Ⱦʻ 1 ʬ׻
  
      real(DBKIND),intent(in) :: xqz_Var(imin:imax,jmin:jmax,kmin:kmax) 
      real(DBKIND)            :: xyz_dy_xqz(imin:imax,jmin:jmax,kmin:kmax)
      integer                 :: jy                          

      ! 
      ! * 0 ɤˤϥޥ󥤥ץͤѤ٤
      !
      xyz_dy_xqz = 0.0d0

      ! 1 ʬη׻
      !
      do jy = jmin+2, jmax-1
        xyz_dy_xqz(:,jy,:) = &
          &   ((xqz_Var(:,jy,:)   - xqz_Var(:,jy-1,:))*9.0d0/(8.0d0*y_dy(jy)) &
          & - ((xqz_Var(:,jy+1,:) - xqz_Var(:,jy-2,:))/(24.0d0*y_dy(jy))))
      end do

    end function xyz_dy_xqz
!--------------------------------------------------------------------
    function aqa_dy_aya(aya_Var)
      ! Ⱦʻ 1 ʬ׻
  
      real(DBKIND),intent(in) :: aya_Var(imin:imax,jmin:jmax,kmin:kmax) 
      real(DBKIND)            :: aqa_dy_aya(imin:imax,jmin:jmax,kmin:kmax)
      integer                 :: jy                          

      ! 
      ! * 0 ɤˤϥޥ󥤥ץͤѤ٤
      !
      aqa_dy_aya = 0.0d0

      ! 1 ʬη׻
      !
      do jy = jmin+1, jmax-2
        aqa_dy_aya(:,jy,:) = &
          &   ((aya_Var(:,jy+1,:) - aya_Var(:,jy,:))*9.0d0/(8.0d0*q_dy(jy)) &
          & - ((aya_Var(:,jy+2,:) - aya_Var(:,jy-1,:))/(24.0d0*q_dy(jy))))
      end do

    end function aqa_dy_aya
!--------------------------------------------------------------------
    function xyz_dz_xyr(xyr_Var)
      ! Ⱦʻ 1 ʬ׻
  
      real(DBKIND),intent(in) :: xyr_Var(imin:imax,jmin:jmax,kmin:kmax) 
      real(DBKIND)            :: xyz_dz_xyr(imin:imax,jmin:jmax,kmin:kmax)
      integer                 :: kz

      ! 
      ! * 0 ɤˤϥޥ󥤥ץͤѤ٤
      !
      xyz_dz_xyr = 0.0d0

      ! 1 ʬη׻
      !
      do kz = kmin+2, kmax-1
        xyz_dz_xyr(:,:,kz) = &
          &   ((xyr_Var(:,:,kz)   - xyr_Var(:,:,kz-1))*9.0d0/(8.0d0*z_dz(kz)) &
          & - ((xyr_Var(:,:,kz+1) - xyr_Var(:,:,kz-2))/(24.0d0*z_dz(kz))))
      end do

    end function xyz_dz_xyr
!--------------------------------------------------------------------
    function aar_dz_aaz(aaz_Var)
      ! Ⱦʻ 1 ʬ׻
  
      real(DBKIND),intent(in) :: aaz_Var(imin:imax,jmin:jmax,kmin:kmax) 
      real(DBKIND)            :: aar_dz_aaz(imin:imax,jmin:jmax,kmin:kmax)
      integer                 :: kz

      ! 
      ! * 0 ɤˤϥޥ󥤥ץͤѤ٤
      !
      aar_dz_aaz = 0.0d0

      ! 1 ʬη׻
      ! * r_dz_z ѤƷ׻
      !
      do kz = kmin+1, kmax-2
        aar_dz_aaz(:,:,kz) = &
          &   ((aaz_Var(:,:,kz+1) - aaz_Var(:,:,kz))*9.0d0/(8.0d0*r_dz(kz)) &
          & - ((aaz_Var(:,:,kz+2) - aaz_Var(:,:,kz-1))/(24.0d0*r_dz(kz))))
      end do

    end function aar_dz_aaz
!--------------------------------------------------------------------
end module xyz_deriv_c4_module
